<?php
session_start();
include('config.php');
include($rutaPhp.$rutaHtml.'/maqueta/includes.php');

include($rutaPhp.$rutaHtml.'/acceso/control.php');
include($rutaPhp.$rutaHtml.'/maqueta/arriba.php');

include($rutaPhp.$rutaHtml.'/librerias/teclado.php');
include($rutaPhp.$rutaHtml.'/librerias/calculadora.php');

?>
<h2>Ubicar Producto</h2>
	
<div id="popupBusqueda" class="popup" style="display:none;overflow:scroll">
    <div class="popupContenidoScroll">
    	<div id="detalleBusqueda"></div>
	</div>
</div>

<?php include($rutaPhp.$rutaHtml.'/contenidos/popup-playas.php'); ?>
    
<form id="formularioCodigo" name="formularioCodigo" method="post" action="" >
	<p>Código EAN/DUN:<br />
	<img src="<?php echo DIR_IMAGENES; ?>/teclado.png" alt="Mostrar teclado" class="iconoTeclado" id="tecladoCodigo" /><input name="codigo" type="text" class="campo mayusculas" id="codigo" size="14" maxlength="14" style="width:350px"/>
	<img id="botonBuscar" src="<?php echo DIR_IMAGENES; ?>/buscar.png" style="width:40px;margin-left:-40px;padding-top:10px;padding-left:50px;margin-bottom:-5px" class="clicable"/>
	<img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" class="boton-x" id="borrarCodigo" style="margin-left:-110px;"/></p>      
</form>
    
<form id="formularioBusqueda" name="formularioBusqueda" method="post" action="" style="display:none">
	<p>Buscar:<br />
	<input name="busqueda" type="text" class="campo mayusculas" id="busqueda" size="20" maxlength="" style="width:350px"/>
	<img id="botonCodigo" src="<?php echo DIR_IMAGENES; ?>/barcode.png" style="width:40px;margin-left:-40px;padding-top:10px;padding-left:50px;margin-bottom:-5px" class="clicable"/>
	<img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" class="boton-x" id="borrarBusqueda" style="margin-left:-110px;"/>
	</p>
</form>
    
<div id="fichaInfoProducto" style="display:none;">
	
    <h2><span id="articuloCodigo"></span> <span id="articuloDescripcion"></span></h2>
	
    <p id="mostrarEmbalajePrimarioCaja" style="display:none" >Unidades por caja: <input name="EmbalajePrimarioCaja" id="EmbalajePrimarioCaja" type="<?php if($informarUnidadesPorCaja) { ?>text<?php } else { ?>hidden<?php } ?>" class="campo cantidad" style="width:100px"/></p>
    

        
	<p>Ubicación inicial:<br />
	<img src="<?php echo DIR_IMAGENES; ?>/teclado.png" alt="Mostrar teclado" class="iconoTeclado" id="tecladoUbicacionInicial" /><input name="ubicacionInicial" type="text" class="campo mayusculas" id="ubicacionInicial" size="14" maxlength="14"/>
	<img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" class="boton-x" id="borrarUbicacionInicial" style="margin-left:-60px;"/><img src="<?php echo DIR_IMAGENES; ?>/playa.png" alt="Seleccionar Playa" id="botonPlayas" style="width:45px;cursor:pointer;padding-left:15px;margin-right:-52px;margin-bottom:-10px"/></p>

	<table style="margin:10px auto">
		<tr>
			<td class="verLote" style="display:none"><p class="sinMargen">Lote:</p></td>
			<td class="verFechaCaducidad" style="display:none">Fecha Caducidad:</td>
			<td class="verNumeroSerie" style="display:none">Nº de Serie:</td>
		</tr>
		<tr>
			<td class="verLote" style="display:none">
            	<p class="sinMargen"><img src="<?php echo DIR_IMAGENES; ?>/teclado.png" alt="Mostrar teclado" class="iconoTeclado" id="tecladoLote" /><input name="articuloLote" type="text" class="campo mayusculas" id="articuloLote" size="14" maxlength="14"/><img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" class="boton-x" id="borrarLote" style="margin-left:-50px;"/></p>
            </td>
			<td class="verFechaCaducidad" style="display:none"><input name="articuloFechaCaducidad" id="articuloFechaCaducidad" type="text" class="campo mayusculas" /></td>
			<td class="verNumeroSerie" style="display:none"><input name="articuloNumeroSerie" id="articuloNumeroSerie" type="text" class="campo mayusculas" /></td>
		</tr>
	</table>
	
    <input name="TieneGestionFCaducidad" id="TieneGestionFCaducidad" type="hidden"/>
	<input name="TieneGestionLotes" id="TieneGestionLotes" type="hidden"/>
	<input name="TieneGestionNSerie" id="TieneGestionNSerie" type="hidden"/>
	<input name="tipoCodigo" id="tipoCodigo" type="hidden"/>

	<div id="fichaUbicacion" style="display:none">

        <table class="tablaFormateada" width="450">
            <tr><th></th><th>Unidades</th><th>Cajas</th></tr>
            <tr><td align="left">Cantidad en Ubicación:</td><td id="cantidadUbicacion" align="right"></td><td id="cantidadUbicacionCajas" align="right"></td></tr>
            <tr><td align="left">Cantidad leída:</td><td id="cantidadLeida" align="right"></td><td id="cantidadLeidaCajas" align="right"></td></tr>
            <tr><td align="left">Cantidad disponible para ubicar:</td><td id="cantidadDisponible" align="right"></td><td id="cantidadDisponibleCajas" align="right"></td></tr>
            <tr><td align="left">Cantidad en Preparaciones abiertas:</td><td id="cantidadNoTocable" align="right"></td><td id="cantidadNoTocableCajas" align="right"></td></tr>
        </table>
        
        <p>Ubicación Picking asignada: <strong><span id="posicionPicking"></span></strong></p>
        </table>
            
        <p>Ubicación final:<br />
        <img src="<?php echo DIR_IMAGENES; ?>/teclado.png" alt="Mostrar teclado" class="iconoTeclado" id="tecladoUbicacionFinal" /><input name="ubicacionFinal" type="text" class="campo mayusculas" id="ubicacionFinal" size="14" maxlength="14"/>
        <img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" class="boton-x" id="borrarUbicacionFinal" style="margin-left:-60px;"/></p>
    
        <div style="width:360px;margin:0 auto">
            <p style="margin:20px 0 5px 0">Cantidad (<span id="etiqueta">Unidades</span>)</p>
            <div style="width:360px;height:53px;position:relative;margin:0;text-align:left">
            <img src="<?php echo DIR_IMAGENES; ?>/Cajas.png" alt="Informar en Cajas" class="iconoTeclado" id="iconoUnidades" /><input name="cantidad" type="text" class="campo cantidad" id="cantidad" style="font-size:2em;width:330px;height:43px;position:absolute;left:10px;"/><img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" id="borrarCantidad" style="position:absolute;right:5px;cursor:pointer;"/>
            </div>
        </div>
        
        <p><input type="submit" name="botonAceptar" id="botonAceptar" value="Aceptar" class="boton"/></p>
    
    </div>

</div>

    
<script>
	
	function reinicia(parcial,rebusqueda) {
	
		if(!parcial) {
			$('#articuloCodigo').empty();
			$('#articuloDescripcion').empty();
			$('#EmbalajePrimarioCaja').val('');
			$('#mostrarEmbalajePrimarioCaja').hide();
			$('#fichaInfoProducto').hide();
		}
		
		if(!parcial || rebusqueda) {
			$('#fichaUbicacion').hide();
		}
		
		$('#ubicacionInicial').val('');
		$('#ubicacionFinal').val('');
		$('#articuloFechaCaducidad').val('');
		$('#articuloLote').val('');
		$('#articuloNumeroSerie').val('');
		
		$('#cantidad').val('');
		
		$('#cantidadUbicacion').empty();
		$('#cantidadLeida').empty();
		$('#cantidadDisponible').empty();
		$('#cantidadNoTocable').empty();
		
		$('#cantidadUbicacionCajas').empty();
		$('#cantidadLeidaCajas').empty();
		$('#cantidadDisponibleCajas').empty();
		$('#cantidadNoTocableCajas').empty();

	}
	
	function cargaCantidadesPorUbicacionLote() {
	
		var lote;
		if( $('#articuloLote').val()!='' && $('#articuloLote').val()!=null ) lote=$('#articuloLote').val();
		else lote='-';
		
		//alert("producto: "+$('#articuloCodigo').html()+" ubicacion: "+$('#ubicacionInicial').val()+" lote: "+lote+" embalajePrimario: "+$('#EmbalajePrimarioCaja').val());
		
		
		
		$('#popupCargando').show();
		
		
		
		$.post( "<?php echo $rutaHtml; ?>/contenidos/cargar-producto-cantidades-ubicacion.php?traza=<?php echo $_GET['traza']; ?>", { 'producto' : $('#articuloCodigo').html() , 'ubicacion' : $('#ubicacionInicial').val() , 'lote' : lote , 'embalajePrimario' : $('#EmbalajePrimarioCaja').val() })
		.done(function(data) {
				
				//alert(data);
				
				
				
				var valores=data.split('#');
				
				if(valores[0]=='OK') {
				
					var valores=data.split('#');
					
					$('#cantidadUbicacion').html(valores[1]);
					$('#cantidadLeida').html(valores[2]);
					$('#cantidadDisponible').html(valores[3]);
					$('#cantidadNoTocable').html(valores[4]);
					
					$('#cantidadUbicacionCajas').html( valores[1] / $('#EmbalajePrimarioCaja').val() );
					$('#cantidadLeidaCajas').html( valores[2] / $('#EmbalajePrimarioCaja').val() );
					$('#cantidadDisponibleCajas').html( valores[3] / $('#EmbalajePrimarioCaja').val() );
					$('#cantidadNoTocableCajas').html( valores[4] / $('#EmbalajePrimarioCaja').val() );

					$('#fichaUbicacion').show();
					$("#ubicacionFinal").focus();
				
				}
				else {

					alert(valores[1])
					.done( function(){
						reinicia(true,true);
						$('#ubicacionInicial').focus();
					});
				}
				
				
				$('#popupCargando').hide();
		});
		
		
		
	}
	
	function carga( articuloCodigo,articuloDescripcion,embalajePrimarioCaja,tieneGestionFCaducidad,tieneGestionLotes,tieneGestionNSerie,tipoCodigo,posicionPicking ) {

		$('#fichaInfoProducto').show();
			
		$('#articuloCodigo').html( articuloCodigo );
		$('#articuloDescripcion').html( articuloDescripcion );
		
		$('#posicionPicking').html( posicionPicking );
		
		$('#TieneGestionFCaducidad').val( tieneGestionFCaducidad );
		$('#TieneGestionLotes').val( tieneGestionLotes );
		$('#TieneGestionNSerie').val( tieneGestionNSerie );
		
		$('#EmbalajePrimarioCaja').val( embalajePrimarioCaja );
		$('#tipoCodigo').val( tipoCodigo );
		
		<?php if($informarUnidadesPorCaja) { ?>
		
			if( tipoCodigo=='EAN' ) $('#mostrarEmbalajePrimarioCaja').show();
		
			$('#etiqueta').html('Cajas');
			$('#iconoUnidades').attr('src','img/Unidades.png');
			$('#iconoUnidades').show();
		
		<?php } else { ?>
		
		if(embalajePrimarioCaja>1 && tipoCodigo=='DUN') {
			$('#etiqueta').html('Cajas');
			$('#iconoUnidades').attr('src','img/Unidades.png');
			$('#iconoUnidades').show();
		}
		else {
			$('#etiqueta').html('Unidades');
			$('#iconoUnidades').hide();
		}
		
		<?php } ?>
		
		if(tieneGestionFCaducidad=='S') $('.verFechaCaducidad').show();
		else { $('#articuloFechaCaducidad').val('-'); $('.verFechaCaducidad').hide(); }
		
		if(tieneGestionLotes=='S') $('.verLote').show();
		else { $('#articuloLote').val('-'); $('.verLote').hide(); }
		
		if(tieneGestionNSerie=='S') $('.verNumeroSerie').show();
		else { $('#articuloNumeroSerie').val('-'); $('.verNumeroSerie').hide(); }
	
	}
	
	
	
	
	$(document).ready(function() {
	
		$('#codigo').focus();
		
		$('#tecladoCodigo').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#codigo').val() );
			$('#valorOculto').val( $('#codigo').val() );
			$('#enter').attr('campoValor','codigo');
			$('#enter').attr('formulario','formularioCodigo');
					
		});
				
		$('#borrarCodigo').on("click",function(){
				
			$("#codigo").val('');
			$("#codigo").focus();
			reinicia();
					
		});
				
		$('#busqueda').on("click",function(){
					
			$('#teclado').show();
			$('#valor').val( $('#busqueda').val() );
			$('#valorOculto').val( $('#busqueda').val() );
			$('#enter').attr('campoValor','busqueda');
			$('#enter').attr('formulario','formularioBusqueda');
					
		});
				
		$('#borrarBusqueda').on("click",function(){
				
			$("#busqueda").val('');
			$("#busqueda").focus();
			reinicia();
					
		});
				
		$('#formularioCodigo').on("submit",function(e){

			e.preventDefault();
			reinicia();
					
			if( $('#codigo').val()!='' ) {
						
				$('#popupCargando').show();
					
				$.post( "<?php echo $rutaHtml; ?>/contenidos/leer-codigo-barras.php", { 'codigo' : $('#codigo').val() } )
				.done(function(data) {
					
					var datos=data.split('#');
							
					if( datos[0] ) {
						carga(datos[0],datos[3],datos[2],datos[4],datos[5],datos[6],datos[1],datos[7]);
						$("#ubicacionInicial").focus();
					}
					else {
						alert("ERROR: No se ha encontrado ningún producto relacionado con ese código.");
					}
							
					$('#popupCargando').hide();
			
				});
			}
					
		});
				
		$('#formularioBusqueda').on("submit",function(e){
				
			e.preventDefault();
			reinicia();
			
			if( $('#busqueda').val()!='' ) {
				
				$('#popupCargando').show();
						
				$.post( "<?php echo $rutaHtml; ?>/contenidos/inventario-buscar-producto.php", { 'cadena' : $('#busqueda').val() , 'ubicacion' : 'si' })
				.done(function(data) {
				
					$('#popupCargando').hide();
					$('#popupBusqueda').show();
					$('#detalleBusqueda').html(data);
				
				});
				
			}
					
		});
				
		$('#botonBuscar').on("click",function(){
			
			$('#formularioCodigo').hide();
			$('#formularioBusqueda').show();
			$('#busqueda').focus();
					
		});
				
		$('#botonCodigo').on("click",function(){
				
			$('#formularioCodigo').show();
			$('#codigo').focus();
			$('#formularioBusqueda').hide();
					
		});
		
		$('#popupBusqueda').on("click",function(){
			$('#popupBusqueda').hide();
		});
		
		$('#botonAceptar').on("click",function(e){
		
			e.preventDefault();
			
			if( $('#ubicacionInicial').val()=='' ) {
				alert('Es obligatorio indicar la Ubicación inicial.')
				.done( function(){ $('#ubicacionInicial').focus();  });
			}
			else if( $('#ubicacionFinal').val()=='' ) {
				alert('No has indicado donde se va a ubicar el producto.')
				.done( function(){ $('#ubicacionFinal').focus();  });
			}
			else if( $('#TieneGestionFCaducidad').val()=='S' && $('#articuloFechaCaducidad').val()=='' ) {
				alert('Es obligatorio introducir la Fecha de Caducidad.')
				.done( function(){ $('#articuloFechaCaducidad').focus(); });
			}
			else if( $('#TieneGestionLotes').val()=='S' && $('#articuloLote').val()=='' ) {
				alert('Es obligatorio introducir el Lote.')
				.done( function(){ $('#articuloLote').focus(); });
			}
			else if( $('#TieneGestionNSerie').val()=='S' && $('#articuloNumeroSerie').val()=='' ) {
				alert('Es obligatorio introducir el Nº de Serie.')
				.done( function(){ $('#articuloNumeroSerie').focus(); });
			}
			else if( ! $('#cantidad').val() > 0 ) {
				alert('No se ha introducido ninguna cantidad.')
				.done( function(){ $('#cantidad').focus();  });
			}
			else {
				
				$('#popupCargando').show();
				
				var cantidad;
				
				if( $('#iconoUnidades').attr('src')=='img/Unidades.png' && $('#iconoUnidades').is(':visible') ) {
					cantidad=$('#cantidad').val()*$('#EmbalajePrimarioCaja').val();
				}
				else cantidad=$('#cantidad').val() //La cantidad está en unidades
				
				
				
				//alert('ubicacionInicial: '+$('#ubicacionInicial').val()+'<br>ubicacionFinal: '+$('#ubicacionFinal').val()+'<br>codigo: '+$('#articuloCodigo').html()+'<br>lote: '+$('#articuloLote').val()+'<br>cantidad: '+cantidad+'<br>embalajePrimario: '+$('#EmbalajePrimarioCaja').val() );
				
				
				
				$.post( "<?php echo $rutaHtml; ?>/contenidos/ubicar.php?traza=si", { 'ubicacionInicial' : $('#ubicacionInicial').val() , 'ubicacionFinal' : $('#ubicacionFinal').val() , 'codigo' : $('#articuloCodigo').html() , 'lote' : $('#articuloLote').val() , 'numeroSerie' : $('#articuloNumeroSerie').val() , 'fechaCaducidad' : $('#articuloFechaCaducidad').val() , 'cantidad' : cantidad , 'embalajePrimario' : $('#EmbalajePrimarioCaja').val() })
				.done(function(data) {
					
					$('#popupCargando').hide();
					
					alert(data);
					/*
					var error=data.split('#');
					if(error[0]==1) alert(error[1] );
					else {
						alert( "Producto ubicado correctamente en "+$("#ubicacionFinal").val() ).done(function() { 
							$('#popupCargando').show();
							window.location="ubicar-producto.php";
						});
					}
					*/
				});
				
				
				
			}
			
		});
		
		$('#iconoUnidades').on("click",function(e){
		
			if( $(this).attr('src')=='img/Cajas.png' ) {
			
				$(this).attr('src','img/Unidades.png');
				$('#etiqueta').html( 'Cajas' );
				
				if( $('#cantidad').val()>0 ) {
					var flotante = parseFloat( $('#cantidad').val() / $('#EmbalajePrimarioCaja').val() );
					var resultado = Math.round(flotante*100)/100;
					if(resultado>0) $('#cantidad').val( resultado );
				}
			
			}
			else {
			
				$(this).attr('src','img/Cajas.png');
				$('#etiqueta').html('Unidades');
				
				if( $('#cantidad').val()>0 ) {
					var resultado = parseInt( $('#cantidad').val() * $('#EmbalajePrimarioCaja').val() );
					if(resultado>0) $('#cantidad').val( resultado );
				}
			
			}
		
		
		});
		
		$('.cantidad').on("click",function(e) {
			$('#calculadora').show();
			$('#valorCalculadora').val( $(this).val() );
			$('#enterCalculadora').attr('campoValor',$(this).attr('id'));
		});
		
		$('#borrarCantidad').on("click",function(e) {
		
			$("#cantidad").val('');
			$("#cantidad").focus();
		
		});
		
		$('#tecladoContenedor').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#contenedor').val() );
			$('#valorOculto').val( $('#contenedor').val() );
			$('#enter').attr('campoValor','contenedor');
			$('#enter').attr('formulario','');
					
		});
		
		$('#borrarContenedor').on("click",function(e) {
		
			$("#contenedor").val('');
			$("#contenedor").focus();
		
		});
		
		$('#articuloLote').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#articuloLote').val() );
			$('#valorOculto').val( $('#articuloLote').val() );
			$('#enter').attr('campoValor','articuloLote');
			$('#enter').attr('formulario','');
			$('#enter').attr('forzarEnter','si');
					
		});
		
		$('#articuloLote').on("change",function(e){
		
			e.preventDefault();
			cargaCantidadesPorUbicacionLote();
				
		});
		
		$('#borrarLote').on("click",function(){
				
			$("#articuloLote").val('');
			$("#articuloLote").focus();
					
		});
		
		$('#tecladoLote').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#articuloLote').val() );
			$('#valorOculto').val( $('#articuloLote').val() );
			$('#enter').attr('campoValor','articuloLote');
			$('#enter').attr('formulario','');
			$('#enter').attr('forzarEnter','si');
					
		});
		
		$('#articuloFechaCaducidad').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#articuloFechaCaducidad').val() );
			$('#valorOculto').val( $('#articuloFechaCaducidad').val() );
			$('#enter').attr('campoValor','articuloFechaCaducidad');
			$('#enter').attr('formulario','');
					
		});
		
		$('#articuloNumeroSerie').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#articuloNumeroSerie').val() );
			$('#valorOculto').val( $('#articuloNumeroSerie').val() );
			$('#enter').attr('campoValor','articuloNumeroSerie');
			$('#enter').attr('formulario','');
					
		});
		
		$('#tecladoUbicacionInicial').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#ubicacionInicial').val() );
			$('#valorOculto').val( $('#ubicacionInicial').val() );
			$('#enter').attr('campoValor','ubicacionInicial');
			$('#enter').attr('formulario','');
					
		});

		$('#borrarUbicacionInicial').on("click",function(){
				
			$("#ubicacionInicial").val('');
			$("#ubicacionInicial").focus();
					
		});
		
		$('#ubicacionInicial').on("change",function(e){
			e.preventDefault();
			if( $('#TieneGestionLotes').val()!='S' ) {
				cargaCantidadesPorUbicacionLote();
			}
			else {
				$("#articuloLote").focus();
			}
		});
		
		$('#tecladoUbicacionFinal').on("click",function(){
				
			$('#teclado').show();
			$('#valor').val( $('#ubicacionFinal').val() );
			$('#valorOculto').val( $('#ubicacionFinal').val() );
			$('#enter').attr('campoValor','ubicacionFinal');
			$('#enter').attr('formulario','');
					
		});
		
		$('#borrarUbicacionFinal').on("click",function(){
			
			$("#ubicacionFinal").val('');
			$("#ubicacionFinal").focus();
					
		});
		
		
		
		$('#ubicacionFinal').on("change",function(e){
			e.preventDefault();
			$("#cantidad").focus();
			$('#calculadora').show();
			$('#valorCalculadora').val( $('#cantidad').val() );
			$('#enterCalculadora').attr('campoValor','cantidad');
		});
		
		$('#botonPlayas').on("click",function(e){
			e.preventDefault();
			$('#popupPlayas').show();
		});
		
		$('.selectorPlaya').on("click",function(e){
			e.preventDefault();
			$('#popupPlayas').hide();
			reinicia(true);
			$("#ubicacionInicial").val( $(this).attr('id') );
			
			if( $('#TieneGestionLotes').val()!='S' ) {
				cargaCantidadesPorUbicacionLote();
			}
			else {
				$("#articuloLote").focus();
			}
		});
		

	});

</script>

<?php
include($rutaPhp.$rutaHtml.'/maqueta/abajo.php');
?>
